#property copyright "Copyright  2008 IceXP"
#property link "icexp@narod.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

extern int bars=100,calculate=10000,future=10,to_past=0;
extern double width=5;

double out[],out1[];

int init()
{
    SetIndexStyle(0,0);
    SetIndexBuffer(0,out);
    SetIndexLabel(0,"Rbn++ 1");
    SetIndexStyle(1,0);
    SetIndexBuffer(1,out1);
    SetIndexLabel(1,"Rbn++ 2");
    Comment("\nCopyright  2008 IceXP");
    IndicatorShortName("Rbn++ ("+bars+", "+calculate+", "+future+", "+to_past+", "+DoubleToStr(width,2)+")");
    return(0);
}

int deinit()
{
    for(int y=0+to_past;y>=-future+to_past;y--) {ObjectDelete("Rbn++_Index="+y); ObjectDelete("Rbn++_Index2="+y);}
    Comment("");
    return(0);
}

int start()
{
    for(int i=bars+to_past;i>=0+to_past;i--) {out[i]=def(i); out1[i]=def_new(i);}
    for(int y=0+to_past;y>=-future+to_past;y--)
    {
        if(y<=0) {ObjectCreate("Rbn++_Index="+y,22,0,Time[0]-y*Period()*60,def(y)); ObjectCreate("Rbn++_Index2="+y,22,0,Time[0]-y*Period()*60,def_new(y));}
        else {ObjectCreate("Rbn++_Index="+y,22,0,Time[y],def(y)); ObjectCreate("Rbn++_Index2="+y,22,0,Time[y],def_new(y));}
        ObjectSet("Rbn++_Index="+y,OBJPROP_ARROWCODE,159);
        ObjectSet("Rbn++_Index="+y,OBJPROP_COLOR,Red); 
        ObjectSet("Rbn++_Index2="+y,OBJPROP_ARROWCODE,159);
        ObjectSet("Rbn++_Index2="+y,OBJPROP_COLOR,Blue); 
    }
    return(0);
}

double def(int x_time)
{
    double sum1=0,sum2=0,k=0,r=0;
    for(int j=calculate+to_past;j>=0+to_past;j--)
    {
        k=MathAbs(j-x_time)*0.8325546/width;
        r=MathExp(-k*k);
        sum1+=Close[j]*r;
        sum2+=r;
    }
    return(sum1/sum2);
}

double def_new(int x_time)
{
    double sum1=0,sum2=0,k=0,r=0;
    for(int j=calculate+to_past;j>=0+to_past;j--)
    {
        k=MathAbs(j-x_time)*0.8325546/width;
        r=MathExp(-k*k);
        sum1+=Open[j]*r;
        sum2+=r;
    }
    return(sum1/sum2);
}